.NET

Reply
Mentor
BrentBurgess1980
Posts: 162
Registered: ‎06-16-2008
Message 1 of 3 (276 Views)
Accepted Solution

Attribute Definitions in BlockJig

276 Views, 2 Replies
10-24-2012 06:18 AM

Hey all,

 

I have a tool that inserts blocks using a jig, and it inserts the block, and attributes (if in the block), but the attributes do not go into the correct position.

 

The code below is the jig that I am using.

 

public class CBlockJig : EntityJig
        {
        private Point3d pos;
        private Dictionary<string, Point3d> attPos;
        private Transaction tr;

        public CBlockJig(Transaction transaction, BlockReference br)
            : base(br)
            {
            pos = br.Position;

            tr = transaction;

            // Initialize our dictionary with the tag /
            // AttributeDefinition position

            attPos = new Dictionary<string, Point3d>();

            BlockTableRecord btr = (BlockTableRecord)tr.GetObject(br.BlockTableRecord, OpenMode.ForRead);

            if (btr.HasAttributeDefinitions)
                {
                foreach (ObjectId id in btr)
                    {
                    DBObject obj = tr.GetObject(id, OpenMode.ForRead);
                    AttributeDefinition ad = obj as AttributeDefinition;

                    if (ad != null)
                        {
                        attPos.Add(ad.Tag, ad.Position);
                        }
                    }
                }
            }

        protected override bool Update()
            {
            BlockReference br = Entity as BlockReference;

            br.Position = pos;

            if (br.AttributeCollection.Count != 0)
                {
                foreach (ObjectId id in br.AttributeCollection)
                    {
                    DBObject obj = tr.GetObject(id, OpenMode.ForRead);
                    AttributeReference ar = obj as AttributeReference;

                    // Apply block transform to att def position

                    if (ar != null)
                        {
                        ar.UpgradeOpen();
                        ar.Position = attPos[ar.Tag].TransformBy(br.BlockTransform);
                        Point3d bpos = br.Position;
                        }
                    }
                }
            return true;
            }

        protected override SamplerStatus Sampler(JigPrompts prompts)
            {
            JigPromptPointOptions opts = new JigPromptPointOptions("\nSelect insertion point: ");
            opts.BasePoint = new Point3d(0, 0, 0);
            opts.UserInputControls = UserInputControls.NoZeroResponseAccepted;

            PromptPointResult ppr = prompts.AcquirePoint(opts);

            if (pos == ppr.Value)
                {
                return SamplerStatus.NoChange;
                }

            pos = ppr.Value;

            return SamplerStatus.OK;
            }

        public PromptStatus Run()
            {
            Document doc =
              Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;

            PromptResult promptResult = ed.Drag(this);
            return promptResult.Status;
            }
        }

 The Attributes appear in the right place while dragging, but once accepted and placed, the attribute is located as if the block were inserted at 0,0.

 

Does anyone have any clue on how to fix this?

 

Thanks

Distinguished Mentor
gasty1001
Posts: 576
Registered: ‎04-11-2010
Message 2 of 3 (257 Views)

Re: Attribute Definitions in BlockJig

10-24-2012 11:56 AM in reply to: BrentBurgess1980
Mentor
BrentBurgess1980
Posts: 162
Registered: ‎06-16-2008
Message 3 of 3 (217 Views)

Re: Attribute Definitions in BlockJig

10-29-2012 06:57 PM in reply to: gasty1001

Thanks Gasty1001.

 

The code I was using was from Kean's site, which did the funny thing with the attribute.

 

I modified the spiderinnet1 one and it works well

 

Thanks

 

Post to the Community

Have questions about Autodesk products? Ask the community.

New Post
Announcements
Are You Going To Be @ AU 2014? Feel free to drop by our AU topic post and share your plans, plug a class that you're teaching, or simply check out who else from the community might be in attendance. Ohh and don't forgot to stop by the Autodesk Help | Learn | Collaborate booths in the Exhibit Hall and meet our community team if you get a chance!